Index: palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- palm/trunk/SOURCE/advec_ws.f90	(revision 4465)
+++ palm/trunk/SOURCE/advec_ws.f90	(revision 4466)
@@ -4854,34 +4800,34 @@
                 ibit3 = REAL( IBITS(advc_flags_m(k,j,i),3,1), KIND = wp )
 
-                v_comp = v(k,j+1,i) + v(k,j+1,i-1) - gv
-                flux_n = v_comp * (                                            &
-                          ( 37.0_wp * ibit5 * adv_mom_5                        &
-                       +     7.0_wp * ibit4 * adv_mom_3                        &
-                       +              ibit3 * adv_mom_1                        &
-                          ) *                                                  &
-                                 ( u(k,j+1,i) + u(k,j,i)   )                   &
-                   -      (  8.0_wp * ibit5 * adv_mom_5                        &
-                       +              ibit4 * adv_mom_3                        &
-                          ) *                                                  &
-                                 ( u(k,j+2,i) + u(k,j-1,i) )                   &
-                   +      (           ibit5 * adv_mom_5                        & 
-                          ) *                                                  &
-                                 ( u(k,j+3,i) + u(k,j-2,i) )                   &
-                                                 )                            
-                                                                              
-                diss_n = - ABS ( v_comp ) * (                                  &
-                          ( 10.0_wp * ibit5 * adv_mom_5                        &
-                       +     3.0_wp * ibit4 * adv_mom_3                        &
-                       +              ibit3 * adv_mom_1                        &
-                          ) *                                                  &
-                                 ( u(k,j+1,i) - u(k,j,i)  )                    &
-                   -      (  5.0_wp * ibit5 * adv_mom_5                        &
-                       +              ibit4 * adv_mom_3                        &
-                          ) *                                                  &
-                                 ( u(k,j+2,i) - u(k,j-1,i) )                   &
-                   +      (           ibit5 * adv_mom_5                        &
-                          ) *                                                  &
-                                 ( u(k,j+3,i) - u(k,j-2,i) )                   &
-                                                      )
+                v_comp(k) = v(k,j+1,i) + v(k,j+1,i-1) - gv
+                flux_n(k) = v_comp(k) * (                                      &
+                           ( 37.0_wp * ibit5 * adv_mom_5                       &
+                        +     7.0_wp * ibit4 * adv_mom_3                       &
+                        +              ibit3 * adv_mom_1                       &
+                           ) *                                                 &
+                                          ( u(k,j+1,i) + u(k,j,i)   )          &
+                    -      (  8.0_wp * ibit5 * adv_mom_5                       &
+                        +              ibit4 * adv_mom_3                       &
+                           ) *                                                 &
+                                          ( u(k,j+2,i) + u(k,j-1,i) )          &
+                    +      (           ibit5 * adv_mom_5                       &
+                           ) *                                                 &
+                                          ( u(k,j+3,i) + u(k,j-2,i) )          &
+                                        )
+
+                diss_n(k) = - ABS ( v_comp(k) ) * (                            &
+                           ( 10.0_wp * ibit5 * adv_mom_5                       &
+                        +     3.0_wp * ibit4 * adv_mom_3                       &
+                        +              ibit3 * adv_mom_1                       &
+                           ) *                                                 &
+                                          ( u(k,j+1,i) - u(k,j,i)   )          &
+                    -      (  5.0_wp * ibit5 * adv_mom_5                       &
+                        +              ibit4 * adv_mom_3                       &
+                           ) *                                                 &
+                                          ( u(k,j+2,i) - u(k,j-1,i) )          &
+                    +      (           ibit5 * adv_mom_5                       &
+                           ) *                                                 &
+                                          ( u(k,j+3,i) - u(k,j-2,i) )          &
+                                                  )
 
 #ifdef _OPENACC
@@ -4892,6 +4838,6 @@
                 ibit3_s = REAL( IBITS(advc_flags_m(k,j-1,i),3,1), KIND = wp )
 
-                v_comp_s = v(k,j,i) + v(k,j,i-1) - gv
-                flux_s   = v_comp_s * (                                        &
+                v_comp_s         = v(k,j,i) + v(k,j,i-1) - gv
+                flux_s_u(k,tn)   = v_comp_s * (                                &
                                    ( 37.0_wp * ibit5_s * adv_mom_5             &
                                 +     7.0_wp * ibit4_s * adv_mom_3             &
@@ -4906,7 +4852,7 @@
                                ) *                                             &
                                      ( u(k,j+2,i) + u(k,j-3,i) )               &
-                                               )
-
-                diss_s   = - ABS ( v_comp_s ) * (                              &
+                                              )
+
+                diss_s_u(k,tn)   = - ABS ( v_comp_s ) * (                      &
                                    ( 10.0_wp * ibit5_s * adv_mom_5             &
                                 +     3.0_wp * ibit4_s * adv_mom_3             &
@@ -4921,10 +4867,69 @@
                                    ) *                                         &
                                      ( u(k,j+2,i) - u(k,j-3,i) )               &
-                                                         )
-#else
-                flux_s = swap_flux_y_local_u(k)
-                diss_s = swap_diss_y_local_u(k)
+                                                        )
 #endif
-
+             ENDDO
+
+             DO  k = nzb_max_l+1, nzt
+
+                u_comp(k) = u(k,j,i+1) + u(k,j,i)
+                flux_r(k) = ( u_comp(k) - gu ) * (                             &
+                               37.0_wp * ( u(k,j,i+1) + u(k,j,i)   )           &
+                             -  8.0_wp * ( u(k,j,i+2) + u(k,j,i-1) )           &
+                             +           ( u(k,j,i+3) + u(k,j,i-2) ) ) * adv_mom_5
+                diss_r(k) = - ABS( u_comp(k) - gu ) * (                        &
+                               10.0_wp * ( u(k,j,i+1) - u(k,j,i)   )           &
+                             -  5.0_wp * ( u(k,j,i+2) - u(k,j,i-1) )           &
+                             +           ( u(k,j,i+3) - u(k,j,i-2) ) ) * adv_mom_5
+#ifdef _OPENACC
+!
+!--             Recompute the left fluxes.
+                u_comp_l           = u(k,j,i) + u(k,j,i-1) - gu
+                flux_l_u(k,j,tn)   = u_comp_l * (                              &
+                             37.0_wp * ( u(k,j,i) + u(k,j,i-1)   )             &
+                           -  8.0_wp * ( u(k,j,i+1) + u(k,j,i-2) )             &
+                           +           ( u(k,j,i+2) + u(k,j,i-3) ) ) * adv_mom_5
+                diss_l_u(k,j,tn)   = - ABS(u_comp_l) * (                       &
+                             10.0_wp * ( u(k,j,i) - u(k,j,i-1)   )             &
+                           -  5.0_wp * ( u(k,j,i+1) - u(k,j,i-2) )             &
+                           +           ( u(k,j,i+2) - u(k,j,i-3) ) ) * adv_mom_5
+
+#endif
+                v_comp(k) = v(k,j+1,i) + v(k,j+1,i-1) - gv
+                flux_n(k) = v_comp(k) * (                                      &
+                               37.0_wp * ( u(k,j+1,i) + u(k,j,i)   )           &
+                             -  8.0_wp * ( u(k,j+2,i) + u(k,j-1,i) )           &
+                             +           ( u(k,j+3,i) + u(k,j-2,i) ) ) * adv_mom_5
+                diss_n(k) = - ABS( v_comp(k) ) * (                             &
+                               10.0_wp * ( u(k,j+1,i) - u(k,j,i)   )           &
+                             -  5.0_wp * ( u(k,j+2,i) - u(k,j-1,i) )           &
+                             +           ( u(k,j+3,i) - u(k,j-2,i) ) ) * adv_mom_5
+#ifdef _OPENACC
+!
+!--             Recompute the south fluxes.
+                v_comp_s         = v(k,j,i) + v(k,j,i-1) - gv
+                flux_s_u(k,tn)   = v_comp_s * (                                &
+                           37.0_wp * ( u(k,j,i) + u(k,j-1,i)   )               &
+                         -  8.0_wp * ( u(k,j+1,i) + u(k,j-2,i) )               &
+                         +           ( u(k,j+2,i) + u(k,j-3,i) ) ) * adv_mom_5
+                diss_s_u(k,tn)   = - ABS( v_comp_s ) * (                       &
+                           10.0_wp * ( u(k,j,i) - u(k,j-1,i)   )               &
+                         -  5.0_wp * ( u(k,j+1,i) - u(k,j-2,i) )               &
+                         +           ( u(k,j+2,i) - u(k,j-3,i) ) ) * adv_mom_5
+#endif
+             ENDDO
+!
+!--          Now, compute vertical fluxes. Split loop into a part treating the
+!--          lowest 2 grid points with indirect indexing, a main loop without
+!--          indirect indexing, and a loop for the uppermost 2 grip points with
+!--          indirect indexing. This allows better vectorization for the main loop.
+!--          First, compute the flux at model surface, which need has to be
+!--          calculated explicetely for the tendency at
+!--          the first w-level. For topography wall this is done implicitely by
+!--          advc_flags_m.
+             flux_t(nzb) = 0.0_wp
+             diss_t(nzb) = 0.0_wp
+             w_comp(nzb) = 0.0_wp
+             DO  k = nzb+1, nzb+2
 !
 !--             k index has to be modified near bottom and top, else array
@@ -4935,168 +4940,78 @@
 
                 k_ppp = k + 3 * ibit8
-                k_pp  = k + 2 * ( 1 - ibit6  )
+                k_pp  = k + 2 * ( 1 - ibit6 )
                 k_mm  = k - 2 * ibit8
 
-                w_comp = w(k,j,i) + w(k,j,i-1)
-                flux_t = w_comp * rho_air_zw(k) * (                            &
-                          ( 37.0_wp * ibit8 * adv_mom_5                        &
-                       +     7.0_wp * ibit7 * adv_mom_3                        &
-                       +              ibit6 * adv_mom_1                        & 
-                          ) *                                                  &
-                             ( u(k+1,j,i)  + u(k,j,i)     )                    &
-                   -      (  8.0_wp * ibit8 * adv_mom_5                        &
-                       +              ibit7 * adv_mom_3                        &
-                          ) *                                                  &
-                             ( u(k_pp,j,i) + u(k-1,j,i)   )                    &
-                   +      (           ibit8 * adv_mom_5                        &
-                          ) *                                                  &
-                             ( u(k_ppp,j,i) + u(k_mm,j,i) )                    &
-                                      )                                       
-                                                                              
-                diss_t = - ABS( w_comp ) * rho_air_zw(k) * (                   &
-                          ( 10.0_wp * ibit8 * adv_mom_5                        &
-                       +     3.0_wp * ibit7 * adv_mom_3                        &
-                       +              ibit6 * adv_mom_1                        &
-                          ) *                                                  &
-                             ( u(k+1,j,i)   - u(k,j,i)    )                    &
-                   -      (  5.0_wp * ibit8 * adv_mom_5                        &
-                       +              ibit7 * adv_mom_3                        &
-                          ) *                                                  &
-                             ( u(k_pp,j,i)  - u(k-1,j,i)  )                    &
-                   +      (           ibit8 * adv_mom_5                        &
-                           ) *                                                 &
-                             ( u(k_ppp,j,i) - u(k_mm,j,i) )                    &
-                                              )
-!
-!--             Calculate the divergence of the velocity field. A respective
-!--             correction is needed to overcome numerical instabilities caused
-!--             by a not sufficient reduction of divergences near topography.
-                div = ( ( u_comp * ( ibit0 + ibit1 + ibit2 )                   &
-                - ( u(k,j,i)   + u(k,j,i-1)   )                                &
-                                    * (                                        &
-                    REAL( IBITS(advc_flags_m(k,j,i-1),0,1),  KIND = wp )       &
-                  + REAL( IBITS(advc_flags_m(k,j,i-1),1,1), KIND = wp )        &
-                  + REAL( IBITS(advc_flags_m(k,j,i-1),2,1), KIND = wp )        &
-                                      )                                        &
-                  ) * ddx                                                      &
-               +  ( ( v_comp + gv ) * ( ibit3 + ibit4 + ibit5 )                &
-                  - ( v(k,j,i)   + v(k,j,i-1 )  )                              &
-                                    * (                                        &
-                     REAL( IBITS(advc_flags_m(k,j-1,i),3,1), KIND = wp )       &
-                   + REAL( IBITS(advc_flags_m(k,j-1,i),4,1), KIND = wp )       &
-                   + REAL( IBITS(advc_flags_m(k,j-1,i),5,1), KIND = wp )       &
-                                      )                                        &
-                  ) * ddy                                                      &
-               +  ( w_comp * rho_air_zw(k) * ( ibit6 + ibit7 + ibit8 )         &
-                - ( w(k-1,j,i) + w(k-1,j,i-1) ) * rho_air_zw(k-1)              &
-                                    * (                                        &
-                     REAL( IBITS(advc_flags_m(k-1,j,i),6,1), KIND = wp )       &
-                   + REAL( IBITS(advc_flags_m(k-1,j,i),7,1), KIND = wp )       &
-                   + REAL( IBITS(advc_flags_m(k-1,j,i),8,1), KIND = wp )       &
-                                      )                                        &  
-                  ) * drho_air(k) * ddzw(k)                                    &
-                ) * 0.5_wp
-
-
-
-                tend(k,j,i) = tend(k,j,i) - (                                  &
-                 ( ( flux_r + diss_r )                                         &
-               -   ( flux_l + diss_l ) ) * ddx                                 &
-               + ( ( flux_n + diss_n )                                         &
-               -   ( flux_s + diss_s ) ) * ddy                                 &
-               + ( ( flux_t + diss_t )                                         &
-               -   ( flux_d + diss_d ) ) * drho_air(k) * ddzw(k)               &
-                                           ) + div * u(k,j,i)
-
-#ifndef _OPENACC
-                swap_flux_x_local_u(k,j) = flux_r
-                swap_diss_x_local_u(k,j) = diss_r
-                swap_flux_y_local_u(k)   = flux_n
-                swap_diss_y_local_u(k)   = diss_n
-#endif
-                flux_d                   = flux_t
-                diss_d                   = diss_t
-!
-!--             Statistical Evaluation of u'u'. The factor has to be applied
-!--             for right evaluation when gallilei_trans = .T. .
-                !$ACC ATOMIC
-                sums_us2_ws_l(k,tn) = sums_us2_ws_l(k,tn)                      &
-                + ( flux_r                                                     &
-                    * ( u_comp - 2.0_wp * hom(k,1,1,0)                   )     &
-                    / ( u_comp - gu + SIGN( 1.0E-20_wp, u_comp - gu )    )     &
-                  + diss_r                                                     &
-                    *   ABS( u_comp - 2.0_wp * hom(k,1,1,0)              )     &
-                    / ( ABS( u_comp - gu ) + 1.0E-20_wp                  )     &
-                  ) *   weight_substep(intermediate_timestep_count)
-!
-!--             Statistical Evaluation of w'u'.
-                !$ACC ATOMIC
-                sums_wsus_ws_l(k,tn) = sums_wsus_ws_l(k,tn)                    &
-                + ( flux_t                                                     &
-                    * ( w_comp - 2.0_wp * hom(k,1,3,0)                   )     &
-                    / ( w_comp + SIGN( 1.0E-20_wp, w_comp )              )     &
-                  + diss_t                                                     &
-                    *   ABS( w_comp - 2.0_wp * hom(k,1,3,0)              )     &
-                    / ( ABS( w_comp ) + 1.0E-20_wp                       )     &
-                  ) *   weight_substep(intermediate_timestep_count)
-
+                w_comp(k) = w(k,j,i) + w(k,j,i-1)
+                flux_t(k) = w_comp(k) * rho_air_zw(k) * (                      &
+                           ( 37.0_wp * ibit8 * adv_mom_5                       &
+                        +     7.0_wp * ibit7 * adv_mom_3                       &
+                        +              ibit6 * adv_mom_1                       &
+                           ) *                                                 &
+                                      ( u(k+1,j,i)   + u(k,j,i)    )           &
+                    -      (  8.0_wp * ibit8 * adv_mom_5                       &
+                        +              ibit7 * adv_mom_3                       &
+                           ) *                                                 &
+                                      ( u(k_pp,j,i)  + u(k-1,j,i)  )           &
+                    +      (           ibit8 * adv_mom_5                       &
+                           ) *                                                 &
+                                      ( u(k_ppp,j,i) + u(k_mm,j,i) )           &
+                                                        )
+
+                diss_t(k) = - ABS( w_comp(k) ) * rho_air_zw(k) * (             &
+                           ( 10.0_wp * ibit8 * adv_mom_5                       &
+                        +     3.0_wp * ibit7 * adv_mom_3                       &
+                        +              ibit6 * adv_mom_1                       &
+                           ) *                                                 &
+                                      ( u(k+1,j,i)   - u(k,j,i)    )           &
+                    -      (  5.0_wp * ibit8 * adv_mom_5                       &
+                        +              ibit7 * adv_mom_3                       &
+                           ) *                                                 &
+                                      ( u(k_pp,j,i)  - u(k-1,j,i)  )           &
+                    +      (           ibit8 * adv_mom_5                       &
+                           ) *                                                 &
+                                      ( u(k_ppp,j,i) - u(k_mm,j,i) )           &
+                                                                 )
              ENDDO
 
-             DO  k = nzb_max_l+1, nzt
-
-                u_comp = u(k,j,i+1) + u(k,j,i)
-                flux_r = ( u_comp - gu ) * (                                   &
-                         37.0_wp * ( u(k,j,i+1) + u(k,j,i)   )                 &
-                       -  8.0_wp * ( u(k,j,i+2) + u(k,j,i-1) )                 &
-                       +           ( u(k,j,i+3) + u(k,j,i-2) ) ) * adv_mom_5
-                diss_r = - ABS( u_comp - gu ) * (                              &
-                         10.0_wp * ( u(k,j,i+1) - u(k,j,i)   )                 &
-                       -  5.0_wp * ( u(k,j,i+2) - u(k,j,i-1) )                 &
-                       +           ( u(k,j,i+3) - u(k,j,i-2) ) ) * adv_mom_5
-
-#ifdef _OPENACC
-!
-!--             Recompute the left fluxes.
-                u_comp_l = u(k,j,i) + u(k,j,i-1) - gu
-                flux_l   = u_comp_l * (                                        &
-                             37.0_wp * ( u(k,j,i) + u(k,j,i-1)   )             &
-                           -  8.0_wp * ( u(k,j,i+1) + u(k,j,i-2) )             &
-                           +           ( u(k,j,i+2) + u(k,j,i-3) ) ) * adv_mom_5
-                diss_l   = - ABS(u_comp_l) * (                                 &
-                             10.0_wp * ( u(k,j,i) - u(k,j,i-1)   )             &
-                           -  5.0_wp * ( u(k,j,i+1) - u(k,j,i-2) )             &
-                           +           ( u(k,j,i+2) - u(k,j,i-3) ) ) * adv_mom_5
-#else
-                flux_l = swap_flux_x_local_u(k,j)
-                diss_l = swap_diss_x_local_u(k,j)
-#endif
-
-                v_comp = v(k,j+1,i) + v(k,j+1,i-1) - gv
-                flux_n = v_comp * (                                            &
-                         37.0_wp * ( u(k,j+1,i) + u(k,j,i)   )                 &
-                       -  8.0_wp * ( u(k,j+2,i) + u(k,j-1,i) )                 &
-                       +           ( u(k,j+3,i) + u(k,j-2,i) ) ) * adv_mom_5
-                diss_n = - ABS( v_comp ) * (                                   &
-                         10.0_wp * ( u(k,j+1,i) - u(k,j,i)   )                 &
-                       -  5.0_wp * ( u(k,j+2,i) - u(k,j-1,i) )                 &
-                       +           ( u(k,j+3,i) - u(k,j-2,i) ) ) * adv_mom_5
-
-#ifdef _OPENACC
-!
-!--             Recompute the south fluxes.
-                v_comp_s = v(k,j,i) + v(k,j,i-1) - gv
-                flux_s   = v_comp_s * (                                        &
-                           37.0_wp * ( u(k,j,i) + u(k,j-1,i)   )               &
-                         -  8.0_wp * ( u(k,j+1,i) + u(k,j-2,i) )               &
-                         +           ( u(k,j+2,i) + u(k,j-3,i) ) ) * adv_mom_5
-                diss_s   = - ABS( v_comp_s ) * (                               &
-                           10.0_wp * ( u(k,j,i) - u(k,j-1,i)   )               &
-                         -  5.0_wp * ( u(k,j+1,i) - u(k,j-2,i) )               &
-                         +           ( u(k,j+2,i) - u(k,j-3,i) ) ) * adv_mom_5
-#else
-                flux_s = swap_flux_y_local_u(k)
-                diss_s = swap_diss_y_local_u(k)
-#endif
-
+             DO  k = nzb+3, nzt-2
+
+                ibit8 = REAL( IBITS(advc_flags_m(k,j,i),8,1), KIND = wp )
+                ibit7 = REAL( IBITS(advc_flags_m(k,j,i),7,1), KIND = wp )
+                ibit6 = REAL( IBITS(advc_flags_m(k,j,i),6,1), KIND = wp )
+
+                w_comp(k) = w(k,j,i) + w(k,j,i-1)
+                flux_t(k) = w_comp(k) * rho_air_zw(k) * (                      &
+                           ( 37.0_wp * ibit8 * adv_mom_5                       &
+                        +     7.0_wp * ibit7 * adv_mom_3                       &
+                        +              ibit6 * adv_mom_1                       &
+                           ) *                                                 &
+                                      ( u(k+1,j,i)  + u(k,j,i)     )           &
+                    -      (  8.0_wp * ibit8 * adv_mom_5                       &
+                        +              ibit7 * adv_mom_3                       &
+                           ) *                                                 &
+                                      ( u(k+2,j,i) + u(k-1,j,i)   )            &
+                    +      (           ibit8 * adv_mom_5                       &
+                           ) *                                                 &
+                                      ( u(k+3,j,i) + u(k-2,j,i) )              &
+                                                        )
+
+                diss_t(k) = - ABS( w_comp(k) ) * rho_air_zw(k) * (             &
+                           ( 10.0_wp * ibit8 * adv_mom_5                       &
+                        +     3.0_wp * ibit7 * adv_mom_3                       &
+                        +              ibit6 * adv_mom_1                       &
+                           ) *                                                 &
+                                      ( u(k+1,j,i)  - u(k,j,i)    )            &
+                    -      (  5.0_wp * ibit8 * adv_mom_5                       &
+                        +              ibit7 * adv_mom_3                       &
+                           ) *                                                 &
+                                      ( u(k+2,j,i)  - u(k-1,j,i)  )            &
+                    +      (           ibit8 * adv_mom_5                       &
+                           ) *                                                 &
+                                      ( u(k+3,j,i) - u(k-2,j,i)   )            &
+                                                                 )
+             ENDDO
+
+             DO  k = nzt-1, nzt-symmetry_flag
 !
 !--             k index has to be modified near bottom and top, else array
